Index: hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy	(revision 69)
+++ hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy	(revision 70)
@@ -617,13 +617,53 @@
 			if(chGrph) {
 				
 				List datas = new ArrayList()
+				List datasList = new ArrayList()
 				
 				chGrph.graphs.each {
-					datas << "{label: '" + it.name + "', data: " + graphDataService.getGraphData(it).toString() + "}"
+					def grphData = graphDataService.getGraphData(it)
+					datasList << grphData
+					datas << "{label: '" + it.name + "', data: " + grphData.toString() + "}"
 				}
 				
-				return [data: datas]
+				if(!params.outputDevice) params.outputDevice = 'none'
 				
+				List outputDevices = new ArrayList()
+				
+				def crit1 = DeviceInfo.createCriteria()
+				outputDevices = crit1 {
+					and {
+						eq("outputDevice",true)
+						eq("hwSet",session.hwSet)
+					}
+					order("friendlyName","asc")
+				}
+				
+				// Fetch action logged data if needed
+				List actionLog = new ArrayList()
+				if(params.outputDevice != 'none') {
+					
+					// Find time span
+					long min = Long.MAX_VALUE
+					long max = 0
+					datasList.each { series ->
+						series.each {
+							if(it[0] < min) min = it[0]
+							if(it[0] > max) max = it[0]
+						}
+					}
+					
+					def crit2 = LoggedData.createCriteria()
+					actionLog = crit2 {
+						and {
+							eq("deviceId",params.outputDevice)
+							between("dateRecieved",new java.util.Date(min),new java.util.Date(max))
+						}
+						order("dateRecieved","asc")
+					}
+				}
+				
+				return [data: datas,actionLog:actionLog,outputDevices:outputDevices]
+				
 			} else {
 				flash.errors = "<p>Invalid graph ID!</p>"
 				redirect(action:'graphs')
Index: hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/SysLogController.groovy
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/SysLogController.groovy	(revision 69)
+++ hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/SysLogController.groovy	(revision 70)
@@ -357,8 +357,6 @@
 		
 		if(params['deviceId'] && params['timeSpan']) {
 			
-			System.out.println("[LiveGraph] Getting for " + params.deviceId + ", time span " + params.timeSpan);
-			
 			java.util.Date beforeNMinutes = new java.util.Date(
 				now.time - (60000 * (params.timeSpan as int))
 			)
@@ -376,8 +374,6 @@
 				data << [it.dateRecieved.getTime(),it.reportedData]
 			}
 			
-			System.out.println(data);
-			
 		}
 		
 		[params:params, data:data]
Index: hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp	(revision 69)
+++ hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp	(revision 70)
@@ -10,6 +10,7 @@
 
 	<erptr:box title="Graph">
 		<g:javascript>
+			var plot;
 			var data = [${data}];
 			var options = {
 				lines: { show: true },
@@ -30,13 +31,31 @@
 				}
 			};
 		</g:javascript>
+		
 		<div class="chart">
-			<flot:plot id="placeholder" style="width: 900px; height: 300px; padding:5px;" data="data" options="options" />
+			<div id='placeholder' style='width: 900px; height: 300px; padding:5px;'></div>
+			<script type='text/javascript'>
+			jQuery(function (){ 
+				plot = jQuery.plot(jQuery("#placeholder"),data, options);
+			});
+			</script>
 		</div>
+		
 		<br />
 		<p>Legend:</p>
 		<div id="legendHolder" name="legendHolder"></div>
-		<br />
+		
+		<table>
+			<g:set var="al2num" value="0" />
+			<g:each in="${actionLog}" var="al2">
+				<tr>
+					<td style="width:20px;"><p style="color:red;font-size:smaller;">${++al2num}</p></td>
+					<td style="width:150px;">${al2.dateRecieved}</td>
+					<td>${al2.reportedData}</td>
+				</tr>
+			</g:each>
+		</table>
+		
 		<p>Display actions:</p>
 		<g:form action="showGraph" method="GET">
 			<g:hiddenField name="id" value="${params.id}" />
@@ -47,6 +66,27 @@
 		<br />
 		
 	</erptr:box>
+	
+	<g:javascript>
+	jQuery( function () {
+		var o;
+		var num = 1;
+		var placeholder = plot.getPlaceholder();
+		var vertica = getMax(plot.getData()[0].datapoints.points);
+		<g:each in="${actionLog}" var="al1">
+			o = plot.pointOffset({ x: ${al1.dateRecieved.time}, y: vertica});
+			placeholder.append("<div style=\"position:absolute;left:" + (o.left + 10) + "px;top:" + o.top + "px;color:red;font-size:smaller\"><a href=\"#\" onclick=\"return false;\" title=\"${al1.reportedData}\">" + num + "</a></div>");
+			num++;
+		</g:each>
+	});
+	function getMax(points) {
+		var max = points[1];
+		for(i = 1; i < points.length; i += 2) {
+			if(points[i] > max) max = points[i];
+		}
+		return max;
+	}
+	</g:javascript>
 
 </body>
 
Index: hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp	(revision 69)
+++ hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp	(revision 70)
@@ -10,22 +10,83 @@
 
 	<erptr:box title="Graph">
 		<g:javascript>
+			var plot;
 			var data = ${data};
 			var options = {
 				lines: { show: true },
 				points: { show: true },
 				xaxis: { mode: "time", timeformat: "%y/%m/%d %H:%M" },
-				legend: { container: '#legendHolder' }
+				legend: { container: '#legendHolder' },
+				grid: {
+					markings: [
+						<g:each in="${actionLog}" var="al">
+							<g:if test="${al == actionLog[-1]}">
+								{ color: 'red', lineWidth: 1, xaxis: { from: ${al.dateRecieved.time}, to: ${al.dateRecieved.time} } }
+							</g:if>
+							<g:else>
+								{ color: 'red', lineWidth: 1, xaxis: { from: ${al.dateRecieved.time}, to: ${al.dateRecieved.time} } },
+							</g:else>
+						</g:each>
+					]
+				}
 			};
 		</g:javascript>
+		
 		<div class="chart">
-			<flot:plot id="placeholder" style="width: 900px; height: 300px; padding:5px;" data="data" options="options" />
+			<div id='placeholder' style='width: 900px; height: 300px; padding:5px;'></div>
+			<script type='text/javascript'>
+			jQuery(function (){ 
+				plot = jQuery.plot(jQuery("#placeholder"),data, options);
+			});
+			</script>
 		</div>
+		
 		<br />
 		<p>Legend:</p>
 		<div id="legendHolder" name="legendHolder"></div>
 		
+		<table>
+			<g:set var="al2num" value="0" />
+			<g:each in="${actionLog}" var="al2">
+				<tr>
+					<td style="width:20px;"><p style="color:red;font-size:smaller;">${++al2num}</p></td>
+					<td style="width:150px;">${al2.dateRecieved}</td>
+					<td>${al2.reportedData}</td>
+				</tr>
+			</g:each>
+		</table>
+		
+		<p>Display actions:</p>
+		<g:form action="showCombGraph" method="GET">
+			<g:hiddenField name="id" value="${params.id}" />
+			<g:select name="outputDevice" from="${outputDevices}" optionKey="deviceId" optionValue="friendlyName" noSelection="['none':'- None -']" style="width:350px;" value="${params.outputDevice}" />
+			&nbsp;&nbsp;&nbsp;
+			<g:submitButton name="outputDeviceSubmit" value="Update" />
+		</g:form>
+		<br />
+		
 	</erptr:box>
+	
+	<g:javascript>
+	jQuery( function () {
+		var o;
+		var num = 1;
+		var placeholder = plot.getPlaceholder();
+		var vertica = getMax(plot.getData()[0].datapoints.points);
+		<g:each in="${actionLog}" var="al1">
+			o = plot.pointOffset({ x: ${al1.dateRecieved.time}, y: vertica});
+			placeholder.append("<div style=\"position:absolute;left:" + (o.left + 10) + "px;top:" + o.top + "px;color:red;font-size:smaller\"><a href=\"#\" onclick=\"return false;\" title=\"${al1.reportedData}\">" + num + "</a></div>");
+			num++;
+		</g:each>
+	});
+	function getMax(points) {
+		var max = points[1];
+		for(i = 1; i < points.length; i += 2) {
+			if(points[i] > max) max = points[i];
+		}
+		return max;
+	}
+	</g:javascript>
 
 </body>
 
Index: hci/trunk/EneraptorSim2/EneraptorSim.java
===================================================================
--- hci/trunk/EneraptorSim2/EneraptorSim.java	(revision 0)
+++ hci/trunk/EneraptorSim2/EneraptorSim.java	(revision 70)
@@ -0,0 +1,42 @@
+import java.sql.*;
+
+public class EneraptorSim {
+
+	public static void main(String[] args) throws Exception {
+
+		Class.forName("org.postgresql.Driver");
+
+		Connection conn = DriverManager.getConnection("jdbc:postgresql://localhost/eneraptor", "eneraptor-hci", "eneraptor-hci");
+
+		// CONFIGURE
+		
+		double val = 24;
+		String deviceId = "thermometer";
+		
+		while(true) {
+		
+			java.util.Date now = new java.util.Date();
+			double a = Math.random();
+			if(a < 0.05)
+				val += 0.1;
+			else if(a > 0.95)
+				val -= 0.1;
+			
+			Statement st = conn.createStatement();
+			String stm = "INSERT INTO logged_data(id, \"version\", date_recieved, device_id, reported_data) VALUES (nextval('hibernate_sequence'), 0, '" + now + "', '" + deviceId + "', '" + val + "');";
+			st.execute(stm);
+			System.out.println("Inserted " + val);
+			st.close();
+			
+			try {
+				Thread.currentThread().sleep(1000);
+			}
+			catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+			
+		}
+	
+	}
+	
+}
\ No newline at end of file
